// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
// Autogenerated from Pigeon (v3.2.9), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package com.amazonaws.amplify.amplify_api;

import android.util.Log;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MessageCodec;
import io.flutter.plugin.common.StandardMessageCodec;
import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

/** Generated class from Pigeon. */
@SuppressWarnings({"unused", "unchecked", "CodeBlock2Expr", "RedundantSuppression"})
public class NativeApiPluginBindings {

  public interface Result<T> {
    void success(T result);
    void error(Throwable error);
  }
  private static class NativeApiPluginCodec extends StandardMessageCodec {
    public static final NativeApiPluginCodec INSTANCE = new NativeApiPluginCodec();
    private NativeApiPluginCodec() {}
  }

  /** Generated class from Pigeon that represents Flutter messages that can be called from Java.*/
  public static class NativeApiPlugin {
    private final BinaryMessenger binaryMessenger;
    public NativeApiPlugin(BinaryMessenger argBinaryMessenger){
      this.binaryMessenger = argBinaryMessenger;
    }
    public interface Reply<T> {
      void reply(T reply);
    }
    static MessageCodec<Object> getCodec() {
      return NativeApiPluginCodec.INSTANCE;
    }

    public void getLatestAuthToken(@NonNull String providerNameArg, Reply<String> callback) {
      BasicMessageChannel<Object> channel =
          new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.NativeApiPlugin.getLatestAuthToken", getCodec());
      channel.send(new ArrayList<Object>(Arrays.asList(providerNameArg)), channelReply -> {
        @SuppressWarnings("ConstantConditions")
        String output = (String)channelReply;
        callback.reply(output);
      });
    }
  }
  private static class NativeApiBridgeCodec extends StandardMessageCodec {
    public static final NativeApiBridgeCodec INSTANCE = new NativeApiBridgeCodec();
    private NativeApiBridgeCodec() {}
  }

  /** Generated interface from Pigeon that represents a handler of messages from Flutter.*/
  public interface NativeApiBridge {
    void addPlugin(@NonNull List<String> authProvidersList, Result<Void> result);

    /** The codec used by NativeApiBridge. */
    static MessageCodec<Object> getCodec() {
      return NativeApiBridgeCodec.INSTANCE;
    }

    /** Sets up an instance of `NativeApiBridge` to handle messages through the `binaryMessenger`. */
    static void setup(BinaryMessenger binaryMessenger, NativeApiBridge api) {
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.NativeApiBridge.addPlugin", getCodec());
        if (api != null) {
          channel.setMessageHandler((message, reply) -> {
            Map<String, Object> wrapped = new HashMap<>();
            try {
              ArrayList<Object> args = (ArrayList<Object>)message;
              List<String> authProvidersListArg = (List<String>)args.get(0);
              if (authProvidersListArg == null) {
                throw new NullPointerException("authProvidersListArg unexpectedly null.");
              }
              Result<Void> resultCallback = new Result<Void>() {
                public void success(Void result) {
                  wrapped.put("result", null);
                  reply.reply(wrapped);
                }
                public void error(Throwable error) {
                  wrapped.put("error", wrapError(error));
                  reply.reply(wrapped);
                }
              };

              api.addPlugin(authProvidersListArg, resultCallback);
            }
            catch (Error | RuntimeException exception) {
              wrapped.put("error", wrapError(exception));
              reply.reply(wrapped);
            }
          });
        } else {
          channel.setMessageHandler(null);
        }
      }
    }
  }
  private static Map<String, Object> wrapError(Throwable exception) {
    Map<String, Object> errorMap = new HashMap<>();
    errorMap.put("message", exception.toString());
    errorMap.put("code", exception.getClass().getSimpleName());
    errorMap.put("details", "Cause: " + exception.getCause() + ", Stacktrace: " + Log.getStackTraceString(exception));
    return errorMap;
  }
}
